﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Bots.DungeonBuddy.Attributes;
using Bots.DungeonBuddy.Helpers;
using Buddy.Coroutines;
using Styx;
using Styx.Common.Helpers;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.CommonBot.POI;
using Styx.Helpers;
using Styx.Pathing;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Vector2 = Tripper.Tools.Math.Vector2;

// ReSharper disable CheckNamespace
namespace Bots.DungeonBuddy.Raids.WarlordsOfDraenor
// ReSharper restore CheckNamespace
{
	public class TheBlackGates : HellfireCitadel
	{
		#region Overrides of Dungeon
	
		public override uint DungeonId
		{
			get { return 986; }
		}

        public override WoWPoint Entrance
        {
            get { return new WoWPoint(4062.25, -2152.08, 51.149); }
        }

        public override WoWPoint ExitLocation
        {
            get { return new WoWPoint(4083.46, -2178.77, 51.149); }
        }

        public override void RemoveTargetsFilter(List<WoWObject> units)
        {
			units.RemoveAll(
				ret =>
				{
                    var unit = ret as WoWUnit;
				    if (unit == null)
				        return false;
                        
                    
					return false;
				});
		}

	    public override void IncludeTargetsFilter(List<WoWObject> incomingunits, HashSet<WoWObject> outgoingunits)
	    {
            foreach (var obj in incomingunits)
            {
                var unit = obj as WoWUnit;
                if (unit != null)
                {

                }
            }
	    }
        
        private const uint MobId_DoomfireSpirit = 92208;
        private const uint MobId_HellfireDeathcaller = 92740;
		private const uint MobId_InfernalDoombringer = 94412;
		private const uint MobId_FelborneOverfiend = 93615;
		private const uint MobId_Dreadstalker = 93616;
		private const uint MobId_ShadowedNetherwalker = 94695;
		private const uint MobId_VoidStar = 95775;

        
        public override void WeighTargetsFilter(List<Targeting.TargetPriority> units)
	    {
            var isMelee = Me.IsMelee();
            var israngedDps = !isMelee && Me.IsDps();
            foreach (var priority in units)
			{
				var unit = priority.Object as WoWUnit;
				if (unit != null)
				{
                    switch (unit.Entry)
                    {
                        case MobId_DoomfireSpirit:
                            priority.Score += 7500;
                            break;
                        case MobId_HellfireDeathcaller:
                                priority.Score += 5500;
							break;
						case MobId_InfernalDoombringer:
								priority.Score += 10000;
                            break;
						case MobId_FelborneOverfiend:
							if(isMelee){
                            priority.Score += 4500;
                            }
                            break;
                        case MobId_Dreadstalker:
                            if(israngedDps){
                            priority.Score += 4000;
                            }
							break;						
						case MobId_ShadowedNetherwalker:
								priority.Score += 7000;
							break;							
						case MobId_VoidStar:
								priority.Score += 8000;
							break;							
						case MobId_Archimonde:
								priority.Score += 500;
							break;
							
						
                    }
				}
			}
		}
        

        #endregion
        
        
		#region Root

		#endregion
        
        #region Archimonde
        
        private const uint MobId_Archimonde = 91331;
		
		private const uint AreaTriggerId_Doomfire = 8732;
        
        // Missing AreaTriggerId for Doomfire
        //private const uint AreaTriggerId_DoomFire = ;

        // http://www.wowhead.com/guides/raiding/hellfire-citadel/archimonde-strategy-guide
        [EncounterHandler((int)MobId_Archimonde, "Archimonde")]
		public Func<WoWUnit, Task<bool>> ArchimondeEncounter()
		{
            
            AddAvoidObject(5, o => o.Entry == AreaTriggerId_Doomfire);
            
            return async boss =>
						 {
							 return false;
						 };
        }
        
        #endregion
       
        
	}
}